<?php
/**
 * 仓库预占流水记录
 */

class console_finder_basic_material_stock_freeze
{
    public $addon_cols = 'bm_id,obj_type,bmsq_id,obj_id,branch_id,shop_id,bill_type';//调用字段
    
    var $_type_list   = array();
    var $_obj_type    = array();
    function __construct()
    {
        $this->_basicMaterialObj = app::get('material')->model('basic_material');
        $this->_shopObj      = app::get('ome')->model('shop');
        $this->_branchObj    = app::get('ome')->model('branch');
        
        $this->_obj_type   = array(1=>'订单', 2=>'仓库');
        
        $stockFreezeObj    = app::get('console')->model('basic_material_stock_freeze');
        $this->_type_list  = $stockFreezeObj->get_type();
    }
    
    var $column_bm_id = '基础物料编号';
    var $column_bm_id_width = 150;
    var $column_bm_id_order = 5;
    function column_bm_id($row)
    {
        $basicMateriaItem    = $this->_basicMaterialObj->dump(array('bm_id'=>$row[$this->col_prefix.'bm_id']), 'material_bn');
        
        return $basicMateriaItem['material_bn'];
    }
    
    var $column_obj_type = '对象类型';
    var $column_obj_type_width = 120;
    var $column_obj_type_order = 10;
    function column_obj_type($row)
    {
        $obj_type    = $row[$this->col_prefix .'obj_type'];
        
        return $this->_obj_type[$obj_type];
    }
    
    var $column_bill_type = '业务类型';
    var $column_bill_type_width = 120;
    var $column_bill_type_order = 20;
    function column_bill_type($row)
    {
        $obj_type   = $row[$this->col_prefix .'obj_type'];
        $bill_type    = abs($row[$this->col_prefix.'bill_type']);
        
        if($obj_type == 1)
        {
            return '订单';
        }
        
        return $this->_type_list[$obj_type][$bill_type];
    }
    
    var $column_obj_id = '单据号';
    var $column_obj_id_width = 180;
    var $column_obj_id_order = 40;
    function column_obj_id($row)
    {
        $obj_id    = $row[$this->col_prefix .'obj_id'];
        $obj_bn    = '';
        
        //订单类型
        if($row[$this->col_prefix .'obj_type'] == 1)
        {
            $orderObj     = app::get('ome')->model('orders');
            $orderInfo    = $orderObj->dump(array('order_id'=>$obj_id), 'order_bn');
            $obj_bn       = $orderInfo['order_bn'];
        }
        //仓库类型
        elseif($row[$this->col_prefix .'obj_type'] == 2)
        {
            switch ($row[$this->col_prefix .'bill_type'])
            {
                //发货单
                case 1:
                    $deliveryObj    = app::get('ome')->model('delivery');
                    $deliveryInfo   = $deliveryObj->dump(array('delivery_id'=>$obj_id), 'delivery_bn');
                    $obj_bn         = $deliveryInfo['delivery_bn'];
                    break;
                //售后单
                case 2:
                    $oReship      = app::get('ome')->model('reship');
                    $reshipInfo   = $oReship->dump(array('reship_id'=>$obj_id), 'reship_bn');
                    $obj_bn       = $reshipInfo['reship_bn'];
                    break;
                //采购退货
                case 3:
                    $returnObj    = app::get('purchase')->model('returned_purchase');
                    $returnInfo   = $returnObj->dump(array('rp_id'=>$obj_id), 'rp_bn');
                    $obj_bn       = $returnInfo['rp_bn'];
                    break;
                //调拨出库
                case 4:
                    $isoObj    = app::get('taoguaniostockorder')->model("iso");
                    $isoInfo   = $isoObj->dump(array('iso_id'=>$obj_id), 'iso_bn');
                    $obj_bn    = $isoInfo['iso_bn'];
                    break;
                //库内转储
                case 5:
                    $oAppro    = app::get('console')->model('stockdump');
                    $tempInfo  = $oAppro->dump(array('stockdump_id'=>$obj_id), 'stockdump_bn');
                    $obj_bn    = $tempInfo['stockdump_bn'];
                    break;
                //唯品会出库
                case 6:
                    $stockoutObj    = app::get('purchase')->model('pick_stockout_bills');
                    $tempInfo       = $stockoutObj->dump(array('stockout_id'=>$obj_id), 'stockout_no');
                    $obj_bn         = $tempInfo['stockout_no'];
                    break;
                //人工库存预占
                case 7:
                    $obj_bn = $obj_id;
                    break;
            }
        }
        
        return $obj_bn;
    }
    
    var $column_branch_id = '仓库';
    var $column_branch_id_width = 120;
    var $column_branch_id_order = 50;
    function column_branch_id($row)
    {
        $branch_name    = '';
        
        if($row[$this->col_prefix .'branch_id'])
        {
            $tempData    = $this->_branchObj->dump(array('branch_id'=>$row[$this->col_prefix .'branch_id']), 'name');
            $branch_name = $tempData['name'];
        }
        
        return $branch_name;
    }
    
    var $column_shop_id = '店铺';
    var $column_shop_id_width = 200;
    var $column_shop_id_order = 60;
    function column_shop_id($row)
    {
        $shop_name    = '';
        
        if($row[$this->col_prefix .'shop_id'])
        {
            $tempData    = $this->_shopObj->dump(array('shop_id'=>$row[$this->col_prefix .'shop_id']), 'name');
            $shop_name   = $tempData['name'];
        }
        
        return $shop_name;
    }
}