<?php
/**
 * 订单接口处理
 *
 * @category
 * @package
 * @author chenping<chenping@shopex.cn>
 * @version $Id: Z
 */
class erpapi_shop_matrix_tmall_response_qianniu extends erpapi_shop_response_abstract
{
    /**
     * ERP订单
     *
     * @var string
     **/
    public $_order_detail= array();

    /**
     * 订单接收格式
     *
     * @var string
     **/
    public $_qnordersdf = array();




    public function address_modify($sdf)
    {

        $this->_qnordersdf = $sdf;
        $this->__apilog['result']['data'] = array('tid'=>$this->_qnordersdf['bizOrderId']);
        $this->__apilog['original_bn']    = $this->_qnordersdf['bizOrderId'];
        $this->__apilog['title']          = '千牛修改订单地址['.$this->_qnordersdf['bizOrderId'].']';

        $this->_order_detail=array();

        $accept = $this->_canModify();

        //本地作配置开启判断
        if ($accept === false) {
            return array();
        }
        $this->_formatSdf();
        if (!$this->_qnordersdf['consignee']){
            $this->__apilog['result']['msg'] = '地区格式有误';
            return array();
        }

        //地址是否发生变化

        $oldconsignee = array(
            'name'      =>  $this->_order_detail['consignee']['name'],
            'area'      =>  $this->_order_detail['consignee']['area'],
            'addr'      =>  $this->_order_detail['consignee']['addr'],
            'zip'       =>  $this->_order_detail['consignee']['zip'],
            'mobile'    =>  $this->_order_detail['consignee']['mobile'],
        );
        $newconsignee = $this->_qnordersdf['consignee'];


        $diff_consignee = array_diff_assoc($newconsignee,$oldconsignee);
        if (!$diff_consignee){
            $this->__apilog['result']['msg'] = '地址没有变化';
           return array();
        }
        $new_order = array();
        $new_order['order_id']      = $this->_order_detail['order_id'];
        $new_order['consignee']     = $newconsignee;
        //暂停成功
        $new_order['confirm']        = 'N';
        $new_order['process_status'] = 'unconfirmed';
        $new_order['pause']          = 'false';
        $convert_order = array(
            'new_order'     =>  $new_order,
            'order_detail'  =>  $this->_order_detail,
        );
        return $convert_order;
    }


    /**
     * 是否接收订单
     *
     * @return void
     * @author
     **/
    protected function _canModify()
    {


        $cloudkefu_conf = app::get('ome')->getConf('shop.cloudkefu.config.'.$this->__channelObj->channel['shop_id']);
        if (!$cloudkefu_conf){
            $this->__apilog['result']['msg'] = 'OMS未开启千牛配置';
            return false;
        }
        $orderModel = app::get('ome')->model('orders');
        $filter = array('order_bn'=>$this->_qnordersdf['bizOrderId'],'shop_id'=>$this->__channelObj->channel['shop_id']);

        $this->_order_detail = $orderModel->dump($filter,'*',array("order_objects"=>array("*",array("order_items"=>array('*')))));
        if (!$this->_order_detail){
            $this->__apilog['result']['msg'] = '订单号不存在';
            return false;
        }
        //只针对未发货  部分发货也不可以修改
        if (!in_array($this->_order_detail['status'],array('active')) || !in_array($this->_order_detail['ship_status'],array('0')) || !in_array($this->_order_detail['process_status'],array('unconfirmed','confirmed','splitting','splited'))){
            $this->__apilog['result']['msg'] = '对应状态不可以 编辑订单';
            return false;
        }

        return true;
    }


    protected function _formatSdf(){
        if (is_string($this->_qnordersdf['modifiedAddress'])) {

            $this->_qnordersdf['modifiedAddress'] = json_decode($this->_qnordersdf['modifiedAddress'],true);
        }
        $modifiedAddress = $this->_qnordersdf['modifiedAddress'];
        //比较地址是否有差异
        $area = $modifiedAddress['province'].'/'.$modifiedAddress['city'].'/'.$modifiedAddress['area'];
        kernel::single('ome_func')->region_validate($area);
        $this->_qnordersdf['consignee'] = array(//area,addr,zip,mobile
                'name'      =>  $modifiedAddress['name'] ? $modifiedAddress['name'] : $this->_order_detail['consignee']['name'],
                'area'      =>  $area,
                'addr'      =>  $modifiedAddress['town']? $modifiedAddress['town'].$modifiedAddress['addressDetail'] : $modifiedAddress['addressDetail'],
                'zip'       =>  $modifiedAddress['postCode'],
                'mobile'    =>  $modifiedAddress['phone'] ? $modifiedAddress['phone'] : $this->_order_detail['consignee']['mobile'],
        );

    }

}
