<?php
/**
 * 基础物料预占流水表
 *
 * @author kamisama.xia@gmail.com 
 * @version 0.1
 */

$db['basic_material_stock_freeze']=array (
  'columns' =>
  array (
    'bmsf_id' => array(
        'type'     => 'int unsigned',
        'required' => true,
        'pkey'     => true,
        'extra'    => 'auto_increment',
        'editable' => false,
    ),
    'bmsq_id' =>
    array (
        'type' => 'int',
        'comment' => '配额ID',
        'label' => '配额ID',
        'editable' => false,
        'in_list' => false,
        'default_in_list' => false,
    ),
    'bm_id' =>
    array (
        'type' => 'int unsigned',
        'comment' => '物料ID',
        'label' => '物料ID',
        'editable' => false,
        'in_list' => false,
        'default_in_list' => false,
    ),
    'obj_id' => array(
        'type' => 'int unsigned',
        'comment' => '对象ID',
        'label' => '对象ID',
        'default' => 0,
        'editable' => false,
        'in_list' => false,
        'default_in_list' => false,
    ),
    'obj_type' => array(
        'type' => 'tinyint(1)',
        'comment' => '对象类型',
        'label' => '对象类型',
        'editable' => false,
        'in_list' => false,
        'default_in_list' => false,
    ),
    'bill_type' => array(
        'type' => 'tinyint(1)',
        'comment' => '业务类型',
        'editable' => false,
        'default' => 0,
    ),
    'shop_id' => array(
        'type' => 'varchar(32)',
        'comment' => '店铺ID',
        'label' => '店铺ID',
        'editable' => false,
        'in_list' => false,
        'default_in_list' => false,
    ),
    'branch_id' => array(
        'type' => 'number',
        'comment' => '仓库ID',
        'label' => '仓库ID',
        'default' => 0,
        'editable' => false,
        'in_list' => false,
        'default_in_list' => false,
    ),
    'num' => array(
        'type' => 'number',
        'comment' => '冻结数',
        'label' => '冻结数',
        'default' => 0,
        'editable' => false,
        'in_list' => true,
        'default_in_list' => true,
        'width' => 100,
        'order' => 90,
    ),
    'create_time' => array(
            'type' => 'time',
            'label' => '创建时间',
            'width' => 130,
            'in_list' => true,
            'order' => 98,
    ),
    'last_modified' => array (
            'label' => '最后更新时间',
            'type' => 'last_modify',
            'width' => 130,
            'in_list' => true,
            'order' => 99,
    ),
  ),
  'index' =>
    array (
    'ind_obj_type_id' =>
        array (
        'columns' =>
            array (
                0 => 'obj_id',
                1 => 'obj_type',
            ),
       ),
    'ind_obj_id' =>
        array (
        'columns' =>
            array (
            0 => 'obj_id',
            ),
        ),
    'ind_bm_id' =>
        array(
        'columns' =>
            array(
                0 => 'bm_id',
            ),
        ),
    ),
  'comment' => '基础物料预占流水表',
  'engine' => 'innodb',
  'version' => '$Rev:  $',
);
