<?php
$db['print_otmpl'] = array(
    'comment' => app::get('ome')->_('打印发货备货单模板管理表'),
    'engine'  => 'innodb',
    'columns' => array(
        'id' => array(
            'type'     => 'mediumint(8)',
            'label'    => app::get('ome')->_('序列号'),            
            'required' => true,
            'pkey'     => true,
            'extra'    => 'auto_increment',
            'editable' => false,
            'order'    => 10,
        ),
        'title' => array(
            'type'            => 'varchar(50)',
            'label'           => app::get('ome')->_('标题'),
            'required'        => true,
            'editable'        => false,
            'searchtype'      => 'has',
            'filtertype'      => 'yes',
            'filterdefault'   => true,
            'in_list'         => true,
            'default_in_list' => true,
            'is_title'        => true,
            'width'           => 'auto',
            'order'           => 20,
        ),
        'type' => array(
            'type' => array(
                'delivery'  => app::get('ome')->_('发货'),
                'stock'     => app::get('ome')->_('备货'),
                'purchase'  => app::get('ome')->_('采购'),
                'pureo'     => app::get('ome')->_('采购入库'),
                'purreturn' => app::get('ome')->_('采购退货'),
                'merge'     => app::get('ome')->_('联合打印'),
                'appropriation'     => app::get('ome')->_('调拔单打印'),
                'vopstockout' => app::get('ome')->_('JIT出库单'),
            ),
            'label' => app::get('ome')->_('打印单类型'),
            'required' => true,
            'editable' => false,
            'filtertype' => 'normal',
            'default_in_list' => true,
            'in_list' => true,
            'width' => 'auto',
            'order' => 30,
        ),
        'content' => array(
            'type'     => 'longtext',
            'label'    => app::get('ome')->_('模板内容'),
            'required' => false,
            'default'  => '',
            'order' => 40,
        ),
        'is_default' => array(
            'type'            => 'bool',
            'label'           => app::get('ome')->_('默认'),
            'required'        => true,
            'default'         => 'false',
            'default_in_list' => true,
            'in_list'         => true,
            'width'           => 'auto',
            'order' => 50,
        ),
        'aloneBtn' => array(
            'type'            => 'bool',
            'label'           => app::get('ome')->_('独立按钮'),
            'required'        => true,
            'default'         => 'false',
            'default_in_list' => false,
            'in_list'         => true,
            'width'           => 'auto',
            'order' => 60,
        ),
        'btnName' => array(
            'type'            => 'varchar(20)',
            'label'           => app::get('ome')->_('独立按钮名称'),
            'default'         => '',
            'default_in_list' => false,
            'in_list'         => true,
            'width'           => 'auto',
            'searchtype'      => 'has',
            'filtertype'      => 'yes',
            'filterdefault'   => true,
            'order' => 70,
        ),
        'deliIdent' => array(
            'type'            => 'varchar(64)',
            'label'           => app::get('ome')->_('发货单类型'),
            'default'         => '',
            'default_in_list' => false,
            'in_list'         => true,
            'width'           => 'auto',
            'searchtype'      => 'has',
            'order' => 80,
        ),
        'disabled' => array(
          'type' => 'bool',
          'default' => 'false',
          'editable' => false,
          'label' => app::get('ome')->_('失效'),
        ),   
        'last_modified' => array(
            'type' => 'time',
            'default' => 0,
            'label' => app::get('ome')->_('最后更新时间'),
        ),  
        'path' => array(
            'type' => 'varchar(255)',
            'label' => app::get('ome')->_('模板路径'),
            'required' => true,
            'default' => '',
        ),
        'open' => array(
            'type'            => 'bool',
            'label'           => app::get('ome')->_('开启'),
            'default'         => 'false',
            'default_in_list' => true,
            'in_list'         => true,
            'width'           => 'auto',
            'filtertype'      => 'normal',
            'filterdefault'   => true,
            'order' => 100,
        ), 

    ),
    'index'   => array(
        'ind_title' => array(
            'columns' => array(
                'title',
            ),
        ),
        'ind_btn_name' => array(
            'columns' => array(
                'btnName',
            ),
        ),
        'ind_deli_indent' => array(
            'columns' => array(
                'deliIdent',
            ),
        ),
    ),
);