<?PHP
/**
 * 订单获取
 *
 * @category 
 * @package 
 * @author chenping<chenping@shopex.cn>
 * @version $Id: Z
 */
class ome_autotask_task_ordertaking
{
    /**
     * @description 订单获取后台处理
     * @access public
     * @param void
     * @return void
     */
    public function process($params, &$error_msg='') 
    {
        $data   = json_decode($params['orderidx'],true);
        $this->_log_id = $log_id = $params['log_id'];
        $this->_sign = $sign = md5('ordertaking_'.$params['orderidx']);
        
        $batchLogModel = app::get('ome')->model('batch_log');
        $affect_row = $batchLogModel->update(array('status'=>'2'),array('log_id'=>$log_id,'status|noequal'=>'1'));
        

        if ($data) {
            // 判断是否在执行中
            if ('running' == cachecore::fetch($sign)) {
                return true;
            }
            cachecore::store($sign, 'running',3600);

            set_error_handler(array($this, '_errorHandler'),E_USER_ERROR | E_ERROR);

            // 简单防止一下并发
            usleep(rand(1,1000000));

            $batch_number = 0;
            foreach ($data as $val) {
                $batch_number += count($val['orders']);
            }
            kernel::database()->exec('UPDATE sdb_ome_batch_log SET batch_number=batch_number+'.$batch_number.' WHERE log_id='.$log_id);

            //订单预处理
            $preProcessLib = new ome_preprocess_entrance();
            $preProcessLib->process($data,$msg);

            //开始自动确认
            $orderAuto = new omeauto_auto_combine();
            //开始处理
            $result = $orderAuto->process($data);

            // 记录一下单次执行的日志
            $memo = array(
                'result' => $result,
                'params' => $data,
            );

            $bdlModel = app::get('ome')->model('batch_detail_log');
            $bdl = array(
                'log_id'     => $log_id,
                'createtime' => time(),
                'memo'       => serialize($memo),
                'status'     => 'success',
            );
            $bdlModel->insert($bdl);

            // 会有锁死情况
            $fail_number = (int) $result['fail'];
            $succ_number = (int) $result['succ'];
            $sql = 'UPDATE sdb_ome_batch_log SET fail_number=fail_number+'.$fail_number.',succ_number=succ_number+'.$succ_number.' WHERE log_id='.$log_id;

            kernel::database()->exec($sql);

            $batchLog = $batchLogModel->dump($log_id);
            $log_text = unserialize($batchLog['log_text']);
            $total = 0;
            foreach ($log_text as $val) {
                $total += count($val['orders']);
            }

            if ($batchLog['batch_number'] >= $total || ($batchLog['fail_number']+$batchLog['succ_number']) > $batchLog['batch_number']){
                $updateData['status'] = '1';
            }


            if($updateData) $batchLogModel->update($updateData,array('log_id'=>$log_id));

            cachecore::store($sign, '',1);
        }

        return  true;
    }

    function _errorHandler($errno, $errstr, $errfile, $errline){
        return true;
    }

}