<?PHP
/**
 * 自有仓储、H5门店发货守护任务处理类
 *
 * @author kamisama.xia@gmail.com
 * @version 0.1
 */

class ome_autotask_timer_syncdlystatus
{
    public function process($params, &$error_msg=''){
        set_time_limit(0);
        ignore_user_abort(1);

        //取发货通知单，未同步仓储、H5门店的再次推送一次
        $deliveryObj = app::get('ome')->model('delivery');
        $time = time()-600;
        $sql = "SELECT delivery_id FROM sdb_ome_delivery WHERE sync_status='0' AND status in ('progress','ready') AND (parent_id=0 OR is_bind='true') AND  create_time<=".$time." ORDER BY delivery_id DESC LIMIT 0,5";
        $deliverys = $deliveryObj->db->select($sql);

        if($deliverys){
            foreach ($deliverys as $delivery){
                ome_delivery_notice::create($delivery['delivery_id']);
            }
        }
        unset($deliverys);

        //取自建仓储已发货，发货通知单未发货的列表信息
        $deliveryObj = app::get('wms')->model('delivery');
        $sql = "SELECT w.delivery_cost_actual,w.branch_id,w.delivery_time,w.outer_delivery_bn,w.weight,o.delivery_id as oms_delivery_id FROM sdb_wms_delivery AS w LEFT JOIN sdb_ome_delivery AS o ON w.outer_delivery_bn=o.delivery_bn WHERE w.status='3' AND o.process='false' AND w.delivery_time<=".$time." ORDER BY w.delivery_id DESC LIMIT 0,5";
        $deliverys = $deliveryObj->db->select($sql);
        $db = kernel::database();
        if($deliverys){
            foreach ($deliverys as $delivery){
                //判断重复是否已经存在出入库明细
                $oms_delivery_id = $delivery['oms_delivery_id'];
                $iostock_sql = "SELECT iostock_id FROM sdb_ome_iostock WHERE type_id='3' AND original_id=".$oms_delivery_id." AND original_bn='".$delivery['outer_delivery_bn']."'";
                $iostock_detail = $db->selectrow($iostock_sql);

                if ($iostock_detail) continue;
                $wms_id = kernel::single('ome_branch')->getWmsIdById($delivery['branch_id']);

                $data = array(
                    'delivery_bn' => $delivery['outer_delivery_bn'],
                    'delivery_time' => $delivery['delivery_time'],
                    'weight' => $delivery['weight'],
                    'delivery_cost_actual' => $delivery['delivery_cost_actual'],
                );

                $res = kernel::single('wms_event_trigger_delivery')->consign($wms_id, $data, true);
            }
        }
        unset($deliverys);

        //取H5门店已发货，发货通知单未发货的列表信息
        $deliveryObj = app::get('wap')->model('delivery');
        $sql = "SELECT w.delivery_cost_actual,w.branch_id,w.logi_id,w.delivery_time,w.outer_delivery_bn,w.delivery_bn,w.weight,w.ship_mobile,w.ship_name FROM sdb_wap_delivery AS w LEFT JOIN sdb_ome_delivery AS o ON w.outer_delivery_bn=o.delivery_bn WHERE w.status='3' AND o.process='false' AND w.delivery_time<=".$time." ORDER BY w.delivery_id DESC LIMIT 0,5";
        $deliverys = $deliveryObj->db->select($sql);

        if($deliverys){
            foreach ($deliverys as $delivery){
                //门店仓不需要wms_id直接走门店绑定的服务端去识别接口
                $store_id      = kernel::single('ome_branch')->isStoreBranch($delivery['branch_id']);
                $channel_id    = $store_id;

                #获取发货仓库对应的门店店铺信息
                $wapDeliveryLib    = kernel::single('wap_delivery');
                $branchShopInfo    = $wapDeliveryLib->getBranchShopInfo($delivery['branch_id']);

                //获取是门店自提还是门店配送
                $corpTypeLib = kernel::single('o2o_corp_type');
                $dlyCorpInfo = $corpTypeLib->get_corp_type($delivery["logi_id"], true);

                //判断是否开启销单校验码 关闭状态下$pickup_code不生成不赋值
                if(app::get('o2o')->getConf('o2o.delivery.confirm.code') == "true"){
                    #生成六位提货单的校验码
                    $wapCodeLib = kernel::single('wap_code');
                    $wapCodeLib->del_code($delivery['delivery_bn']);
                    $pickup_code = $wapCodeLib->gen_code($delivery['delivery_bn']);
                }

                //订单确认参数组织 门店配送短信模板只需要ship_mobile ship_name store_name store_contact_tel
                $request_params = array(
                        'delivery_bn' => $delivery['outer_delivery_bn'],
                        'delivery_time' => $delivery['delivery_time'],
                        'weight' => $delivery['weight'],
                        'delivery_cost_actual' => $delivery['delivery_cost_actual'],
                        'logi_id' => $delivery['logi_id'],
                        'logi_no' => $delivery['outer_delivery_bn'],
                        'dly_corp_type' => $dlyCorpInfo["type"],
                        'pickup_bn' => $delivery['delivery_bn'],
                        'pickup_code' => $pickup_code,
                        'ship_mobile' => $delivery['ship_mobile'],
                        'ship_name' => $delivery['ship_name'],
                        'store_name' => $branchShopInfo['store_name'],#门店名称
                        'store_contact_tel' => $branchShopInfo['tel'] ? $branchShopInfo['tel'] : $branchShopInfo['mobile'],#门店联系电话
                );

                //[自提]需要门店地址
                if($dlyCorpInfo["type"] == "o2o_pickup")
                {
                    $request_params["store_addr"] = $branchShopInfo['addr'];//自提短信需要门店地址
                }

                $res = kernel::single('wms_event_trigger_delivery')->consign($channel_id, $request_params, true);
            }
        }

        return true;
    }
}
